 import java.io.*;
import org.antlr.v4.runtime.*;
import org.antlr.v4.runtime.tree.ParseTree;


import parser.*;
import arbre.*;
import visiteurs.*;
public class Main{



	public static void main(String[] a) throws IOException{

		InputStream is = System.in;
		//récupère l’arbre parsé par Antlr
		ParseTree tree = parse(is);
		//le transfore en ast "Noeud"
		//grâce à notre visiteur
		AntlrToAst ata = new AntlrToAst();
		Noeud ast = tree.accept(ata);
		
		
		LecteurGaucheDroite v = new LecteurGaucheDroite();
		ast.accept(v);
		TreePrinter v_ = new TreePrinter();
		System.out.println(ast.accept(v_));
		VisiteurProfondeur vp = new VisiteurProfondeur();
		System.out.println("\nprof : "+ast.accept(vp));

		//Modifier l’ast :
		RetourneEtMultiplie rem = new RetourneEtMultiplie();
		Noeud newAst = ast.accept(rem);
		System.out.println(newAst.accept(v_));
	}






	private static ParseTree parse(InputStream is) throws IOException{
		CharStream input = CharStreams.fromStream(is);
		treesLexer lexer= new treesLexer(input);
		CommonTokenStream lexemes = new CommonTokenStream(lexer);
		treesParser parser = new treesParser(lexemes);
		return parser.tree_int();
	}

}
