 package visiteurs;
import arbre.*;
public class TreePrinter implements Visiteur<String>{
	int index;
	public TreePrinter(){
		this.index=0;
	}
	public String indent(int n){
		String res="";
		for(int i=0;i<n;i++){
			res+="    ";
		}
		return res;
	}
	public String visit(Feuille f){
		return indent(index)+f.value;
	}

	public String visit(Branche b){
		index++;
		String g=b.filsGauche.accept(this);
		String mid=indent(index-1)+"<";
		String d=b.filsDroit.accept(this);
		index--;
		return g+"\n"+mid+"\n"+d;
	}
}

